import { defineConfig } from 'vite'
import vue from '@vitejs/plugin-vue'
import legacyPlugin from 'vite-plugin-legacy'

const path = require('path')
console.log(__dirname);

function resolve_path (dir) {
  return path.join(__dirname, './', dir)
}


export default defineConfig({
  plugins: [
    vue(),
    // The default options are listed below. Pass nothing to use them.
    legacyPlugin({
      // The browsers that must be supported by your legacy bundle.
      // https://babeljs.io/docs/en/babel-preset-env#targets
      targets: [ 'ie >= 11' ],
      // Define which polyfills your legacy bundle needs. They will be loaded
      // from the Polyfill.io server. See the "Polyfills" section for more info.
      polyfills: [
        // Empty by default
      ],
      // Toggles whether or not browserslist config sources are used.
      // https://babeljs.io/docs/en/babel-preset-env#ignorebrowserslistconfig
      ignoreBrowserslistConfig: false,
      // When true, core-js@3 modules are inlined based on usage.
      // When false, global namespace APIs (eg: Object.entries) are loaded
      // from the Polyfill.io server.
      corejs: false,
    })
  ],
  base:'./',
  clearScreen:false,
  resolve:{
    alias:{
      '@':resolve_path('src'),
    }
  },
  server:{
    proxy:{
      '/shzl/api': {
        target: 'https://sjgl.wodcloud.com/shzl/api',  // 接口域名
        changeOrigin: true,  // 是否跨域
        rewrite: (path) => path.replace('/shzl/api', ''),
      },
    }
  },
  build:{
    outDir:'dist/zjhl',
    assetsDir:'static'
  },
  
})
